;10:19  08.05.2022 todo: check after move, done
;13:42  08.05.2022 mixing level,rotate acw works, fixed checklvl error
;15:35  08.05.2022 2nd rotate done
;todo:
;add QAOP - done 16:12  08.05.2022
;choose lvl routine

	device zxspectrum128
        ORG #6000
begin
atrpos equ $5800+6*32+2
	ld sp,$5FFF
;black screen
	call blackscr
;debug grid
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
;random mix
	ld a,r
	ld (R1),a
;setup interrupt
	di
	ld hl,$BE00
	ld de,$BE01
	ld bc,257
	ld (hl),$BF
	ldir
	ld a,$BE
	ld i,a
	im 2
	ld a,$C3
	ld ($BFBF),a
	ld hl,intvec
	ld ($BFC0),hl
	ld hl,song
	call INIT
	ei
	call cholvl
;	jr $

	call blackscr
;fill greed
	ld hl,$4000
gr1:
	ld a,h
	rrca
	sbc a,a
	xor $55
gr2:
	ld (hl),a
	inc l
	jr nz,gr2
	inc h
	ld a,h
	cp $58
	jr nz,gr1
	
gameloop:
	call drvlvl
	call displaylvl ;draw number
;copy data
	call copylvl
;mix tiles
;	jr $ ;for check/debug
;	ld ix,atrpos
;	call mlrotcw
;	jr $
	call mixlvl
;init player coords
	ld de,$0A00
	ld (plx),de
;copy color under cursor
	call calcadr
	ld a,(ix+0)
	ld (plo+0),a
	ld (atrpos+13),a
	ld (ix+0),0

	ld a,(ix+1)
	ld (plo+1),a
	ld (atrpos+14),a
	ld (ix+1),0

	ld a,(ix+32)
	ld (plo+2),a
	ld (atrpos+13+32),a
	ld (ix+32),0

	ld a,(ix+1+32)
	ld (plo+3),a
	ld (atrpos+14+32),a
	ld (ix+1+32),0

;keyscan
keylp:
	ld de,(plx)

;left key 5:F7FE(D4) O:DFFE(D1)
	ld a,$DF
	in a,($FE)
	and 2
	jr z,kl_

	ld a,$F7
	in a,($FE)
	and 16
	jp nz,keyr
kl_:
	inc e
	dec e
	jp z,keyend
; can move
	call calcadr
;copy color
	ei:halt
	ld a,(ix-2)
	ld (ix+0),a
	ld (ix-2),0

	ld a,(ix-1)
	ld (ix+1),a
	ld (ix-1),0

	ld a,(ix-2+32)
	ld (ix+32),a
	ld (ix-2+32),0

	ld a,(ix-1+32)
	ld (ix+32+1),a
	ld (ix-1+32),0

	call wk
;check if done
	call chklvl
	jp nc,nxtlvl

	dec e
	dec e
	jp keyend

;right key 8: EFFE(D2),P:DFFE(D0)
keyr:
	ld a,$DF
	in a,($FE)
	and 1
	jr z,kr_

	ld a,$EF
	in a,($FE)
	and 4
	jp nz,keyu
kr_:
	ld a,e
	cp 10
	jp z,keyend
; can move
	call calcadr
;copy color
	ei:halt
	ld a,(ix+2)
	ld (ix+0),a
	ld (ix+2),0

	ld a,(ix+3)
	ld (ix+1),a
	ld (ix+3),0

	ld a,(ix+34)
	ld (ix+32),a
	ld (ix+34),0

	ld a,(ix+35)
	ld (ix+33),a
	ld (ix+35),0

	call wk
;check if done
	call chklvl
	jp nc,nxtlvl
	inc e,e
	jp keyend

; up key 7:EFFE(D3) Q:FBFE(D0)
keyu:
	ld a,$FB
	in a,($FE)
	and 1
	jr z,ku_
	ld a,$EF
	in a,($FE)
	and 8
	jp nz,keyd
ku_:
	inc d
	dec d
	jp z,keyend
;can move
	call calcadr
;copy color
	ei:halt
	ld a,(ix-64)
	ld (ix+0),a
	ld (ix-64),0

	ld a,(ix-64+1)
	ld (ix+1),a
	ld (ix-64+1),0

	ld a,(ix-32)
	ld (ix+32),a
	ld (ix-32),0

	ld a,(ix-32+1)
	ld (ix+32+1),a
	ld (ix-32+1),0

	call wk
;check if done
	call chklvl
	jp nc,nxtlvl

	dec d,d
	jp keyend

;down key 6:EFFE(D4),A:FDFE(D0)
keyd:
	ld a,$FD
	in a,($FE)
	and 1
	jr z,kd_

	ld a,$EF
	in a,($FE)
	and 16
	jp nz,keyend
kd_:
	ld a,d
	cp 10
	jp z,keyend
;can move
	call calcadr
;copy color
	ei:halt

	ld a,(ix+64)
	ld (ix+0),a
	ld (ix+64),0

	ld a,(ix+64+1)
	ld (ix+1),a
	ld (ix+64+1),0

	ld a,(ix+96)
	ld (ix+32),a
	ld (ix+96),0

	ld a,(ix+96+1)
	ld (ix+32+1),a
	ld (ix+96+1),0

	call wk
;check if done
	call chklvl
	jp nc,nxtlvl

	inc d,d
	jp keyend

keyend:
	ld (plx),de
	jp keylp

nxtlvl:
	ld a,(lvn)
	cp 50
stub:	jr z,stub
	inc a
	ld (lvn),a
	jp gameloop
;-------------------- V A R I A B L E S --------------------
lvt1:
 dw $4000
 db "LEVEL:"
lvtt: db "01",0

lvt2:
 dw $4806
 db "01020304050607080910",0

lvt3:
 dw $4826
 db "11121314151617181920",0

lvt4:
 dw $4846
 db "21222324252627283930",0

lvt5:
 dw $4866
 db "31323334353637383940",0

lvt6:
 dw $4886
 db "41424344454647484950",0


plx: db 0
 db 10 ;Y
lvn: db 1
plo: ds 4 ; color data under player cursor
lvtab:
	dw lv1,lv2,lv3,lv4,lv5,lv6,lv7,lv8,lv9,lv10,lv11,lv12,lv13,lv14,lv15,lv16,lv17,lv18,lv19,lv20
	dw lv21,lv22,lv23,lv24,lv25,lv26,lv27,lv28,lv29,lv30,lv31,lv32,lv33,lv34,lv35,lv36,lv37,lv38,lv39,lv40
	dw lv41,lv42,lv43,lv44,lv45,lv46,lv47,lv48,lv49,lv50
;-------------------- R O U T I N E S --------------------
intvec:
	push ix
	push iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop iy
	pop ix
	ei
	ret

;display proper number
displaylvl:
	ld a,(lvn)
	ld c,-1
sub10:
	inc c
	sub 10
	jr nc,sub10
	add a,58
;	add a,"0"
	ld (lvtt+1),a
	ld a,c
	add a,"0"
	ld (lvtt),a
	ld ix,lvt1
	jp drt
;choose level number
cholvl:
	ld a,$46
	ld (drtc+1),a
	ld ix,lvt2 ; test printing routine
	call drt
	call drt
	call drt
	call drt
	call drt
	ld a,$47
	ld (drtc+1),a
	ld de,0
	call ramk

mklp:
;Enter pressed?
	ld a,$BF
	in a,($FE)
	and 1
	jp nz,mkeyl
	ld a,d
	add a,a
	add a,a
	add a,d
	add a,a
	add a,e
	inc a
	ld (lvn),a
	ret
mkeyl:
	ld a,$F7 ; left is key 5
	in a,($FE)
	and 16
	jp nz,mkeyr
	inc e
	dec e
	jp z,mkend
	call ramk
	dec e
	call ramk
	call wk
	jp mkend
mkeyr:
	ld a,$EF ; right is key 8
	in a,($FE)
	and 4
	jp nz,mkeyu
	ld a,e
	cp 9
	jp z,mkend
	call ramk
	inc e
	call ramk
	call wk
	jp mkend
mkeyu: ; up is key 7
	ld a,$EF
	in a,($FE)
	and 8
	jp nz,mkeyd
	inc d
	dec d
	jp z,mkend
	call ramk
	dec d
	call ramk
	call wk
	jp mkend
mkeyd: ;down key is 6
	ld a,$EF
	in a,($FE)
	and 16
	jp nz,mkend
	ld a,d
	cp 4
	jp z,mkend
	call ramk
	inc d
	call ramk
	call wk

mkend:
	jp mklp
; cursor D=y,E=x
ramk:
	ld l,d
	ld h,0
	ld bc,$5906
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,0
	ld c,e
	add hl,bc
	add hl,bc
	ld c,6*9
	ld a,(hl)
	xor c
	ld (hl),a
	inc hl
	ld a,(hl)
	xor c
	ld (hl),a
	ret
; you know xD
blackscr:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ret
;draws text: IX:pointer at data
drt:
	ld e,(ix+0)
	inc ix
	ld d,(ix+0)
	inc ix
dtlp:
	ld a,(ix+0)
	inc ix
	or a
	ret z
	ld l,a
	ld h,0
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	push de
	ld b,8
dtlp2:
	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz dtlp2
	pop de
;draw attributes
;$40=10.000.00,$58=1011.000
;$48=10.010.00,$59=1011.001
;$50=10.100.00,$5A=1011.010
;       xxx             xxx
	ld l,e
	ld a,d
	rrca
	rrca
	rrca
	and 3
	or $58
	ld h,a
drtc: ld (hl),$46
;next position
	inc e
	jr dtlp
drvlvl: ; draw level
	ld a,(lvn)
	dec a
	ld h,0
	ld l,a
	ld bc,lvtab
	add hl,hl
	add hl,bc
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld hl,atrpos
	
	ld b,12
drl1:
	ld c,12
	push hl
drl2:
	ld a,(de)
	inc de
	ld (hl),a
	inc hl
	dec c
	jr nz,drl2
	pop hl
	push bc
	ld bc,32
	add hl,bc
	pop bc
	djnz drl1
	ret

; IX=attribyte address, E=x,D=y, out:IX=address
;destroys: HL,BC
calcadr:
	ld h,0
	ld l,d
	ld b,h
	ld c,e
;Y*32
	add hl,hl ;*2
	add hl,hl ;*4
	add hl,hl ;*8
	add hl,hl ;*16
	add hl,hl ;*32
	add hl,bc
	ld bc,atrpos
	add hl,bc
	push hl
	pop ix
	ret

;mix level - who knows, how it must be done
mixlvl:
	ld ix,atrpos
	ld c,3+1
ml1:
	ld b,3
	push ix
ml2:
	push bc
	call random
	ld c,a
	and 1
	inc a
	ld b,a
	bit 0,c
	jr z,mlcase1
ml3:
	call mlrotacw
	djnz ml3
	jr mlcase0
mlcase1:
ml4
	call mlrotcw
	djnz ml4
mlcase0:
	pop bc
	inc ix,ix
	inc ix,ix
	djnz ml2
	pop ix
	push bc
	ld bc,64
	add ix,bc
	pop bc
	dec c
	jr nz,ml1
	ret
;rotate tiles anti clock-wise
;12
;43
; 01 23
;+--+--+
;|11|22|+0
;|11|22|+32
;+--+--+
;|44|33|+64
;|44|33|+96
;+--+--+
mlrotacw:
	ld h,(ix+0)
	ld l,(ix+1)
	ld d,(ix+32)
	ld e,(ix+33)
;1<-2
	ld a,(ix+2)
	ld (ix+0),a
	ld a,(ix+3)
	ld (ix+1),a
	
	ld a,(ix+32+2)
	ld (ix+32),a
	ld a,(ix+32+3)
	ld (ix+32+1),a
;2<-3
	ld a,(ix+64+2)
	ld (ix+2),a
	ld a,(ix+64+3)
	ld (ix+3),a

	ld a,(ix+96+2)
	ld (ix+2+32),a
	ld a,(ix+96+3)
	ld (ix+3+32),a
;3<-4
	ld a,(ix+64)
	ld (ix+64+2),a
	ld a,(ix+64+1)
	ld (ix+64+3),a

	ld a,(ix+96)
	ld (ix+96+2),a
	ld a,(ix+96+1)
	ld (ix+96+3),a
;4-<1
	ld (ix+64),h
	ld (ix+64+1),l
	ld (ix+96),d
	ld (ix+96+1),e

	ret

;rotate tiles anticlock-wise
mlrotcw:
; 01 23
;+--+--+
;|11|22|+0
;|11|22|+32
;+--+--+
;|44|33|+64
;|44|33|+96
;+--+--+
	ld h,(ix+0)
	ld l,(ix+1)
	ld d,(ix+32)
	ld e,(ix+33)
;4->1
	ld a,(ix+64);1row
	ld (ix+0),a
	ld a,(ix+64+1)
	ld (ix+1),a
	ld a,(ix+96);2 row
	ld (ix+32),a
	ld a,(ix+96+1)
	ld (ix+32+1),a
;3->4
	ld a,(ix+64+2);1
	ld (ix+64+0),a
	ld a,(ix+64+3)
	ld (ix+64+1),a
	ld a,(ix+96+2);2
	ld (ix+96),a
	ld a,(ix+96+3)
	ld (ix+96+1),a
;2->3
	ld a,(ix+2);1
	ld (ix+64+2),a
	ld a,(ix+3)
	ld (ix+64+3),a
	ld a,(ix+32+2);2
	ld (ix+96+2),a
	ld a,(ix+32+3)
	ld (ix+96+3),a
;1->2
	ld (ix+2),h
	ld (ix+3),l
	ld (ix+2+32),d
	ld (ix+3+32),e
	ret
;get random number
random:
	PUSH BC
	LD A,(R1)
	LD C,A
	LD A,(R2)
	ADD A,C
	LD C,A
	LD (R1),A
	LD A,(R3)
	SUB C
	LD C,A
	LD (R2),A
	RRCA
	LD (R3),A
	LD A,C
	POP BC
	RET
R1      DB #15
R2      DB #70
R3      DB #FD 

copylvl: ;copy level to right place, destroys IX
	ld ix,atrpos
	push bc
	ld c,12
col1:
	ld b,12
	push ix
col2:
	ld a,(ix+0)
	ld (ix+16),a
	inc ix
	djnz col2
	pop ix
	push bc
	ld bc,32
	add ix,bc
	pop bc
	dec c
	jr nz,col1
	pop bc
	ret
;test keypressed?
wk:
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wk
	ret

;check if level done: CY=0 yes,CY=1 no
chklvl:
;	jr $
	ld (sx+2),ix
	ld ix,atrpos
	ld c,6
chl1:
	ld b,6
	push ix
chl2:
	ld a,(ix+0)
	or a
	jr z,underc
	cp (ix+16)
	jp nz,notdone

	ld a,(ix+1)
	cp (ix+16+1)
	jp nz,notdone

	ld a,(ix+32)
	cp (ix+16+32)
	jp nz,notdone

	ld a,(ix+32+1)
	cp (ix+16+32+1)
	jp nz,notdone
	jp nxtp
;check under cursor data
underc:
	ld a,(plo+0)
	cp (ix+16)
	jp nz,notdone

	ld a,(plo+1)
	cp (ix+1+16)
	jp nz,notdone

	ld a,(plo+2)
	cp (ix+32+16)
	jp nz,notdone

	ld a,(plo+3)
	cp (ix+33+16)
	jp nz,notdone
nxtp:
	inc ix
	inc ix
	djnz chl2
	pop ix
	push bc
	ld bc,64
	add ix,bc
	pop bc
	dec c
	jp nz,chl1
;	ld a,1:out ($FE),a
	xor a
	jr ex_routine
notdone:
	pop ix
	scf
ex_routine:
sx:ld ix,0
	ret

;-------------------- L E V E L S --------------------
;lv1: incbin "lvl\1.bin"
lv1: incbin "lvl\1.bin"
lv2: incbin "lvl\2.bin"
lv3: incbin "lvl\3.bin"
lv4: incbin "lvl\4.bin"
lv5: incbin "lvl\5.bin"
lv6: incbin "lvl\6.bin"
lv7: incbin "lvl\7.bin"
lv8: incbin "lvl\8.bin"
lv9: incbin "lvl\9.bin"
lv10: incbin "lvl\10.bin"
lv11: incbin "lvl\11.bin"
lv12: incbin "lvl\12.bin"
lv13: incbin "lvl\13.bin"
lv14: incbin "lvl\14.bin"
lv15: incbin "lvl\15.bin"
lv16: incbin "lvl\16.bin"
lv17: incbin "lvl\17.bin"
lv18: incbin "lvl\18.bin"
lv19: incbin "lvl\19.bin"
lv20: incbin "lvl\20.bin"
lv21: incbin "lvl\21.bin"
lv22: incbin "lvl\22.bin"
lv23: incbin "lvl\23.bin"
lv24: incbin "lvl\24.bin"
lv25: incbin "lvl\25.bin"
lv26: incbin "lvl\26.bin"
lv27: incbin "lvl\27.bin"
lv28: incbin "lvl\28.bin"
lv29: incbin "lvl\29.bin"
lv30: incbin "lvl\30.bin"
lv31: incbin "lvl\31.bin"
lv32: incbin "lvl\32.bin"
lv33: incbin "lvl\33.bin"
lv34: incbin "lvl\34.bin"
lv35: incbin "lvl\35.bin"
lv36: incbin "lvl\36.bin"
lv37: incbin "lvl\37.bin"
lv38: incbin "lvl\38.bin"
lv39: incbin "lvl\39.bin"
lv40: incbin "lvl\40.bin"
lv41: incbin "lvl\41.bin"
lv42: incbin "lvl\42.bin"
lv43: incbin "lvl\43.bin"
lv44: incbin "lvl\44.bin"
lv45: incbin "lvl\45.bin"
lv46: incbin "lvl\46.bin"
lv47: incbin "lvl\47.bin"
lv48: incbin "lvl\48.bin"
lv49: incbin "lvl\49.bin"
lv50: incbin "lvl\50.bin"
fnt:incbin "Roman.fnt"
song:incbin "smr-stevie.PT3"
plyr:include "PTxPlay.a80"
end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "quiltrex.code",begin ,end-begin
